

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.table.*;
import javax.swing.event.*;
import javax.sound.midi.*;
import java.util.Vector;
import java.util.StringTokenizer;
import java.io.File;
import java.io.IOException;

public class PaklSound implements Runnable
{
    Sequencer sequencer;
    Sequence sequence;
    Synthesizer synthesizer;
    Instrument instruments[];
    ChannelData channels[];
    ChannelData cc;   

    PaklSound localPaklSound;
    public PaklSound() 
    {
        localPaklSound= this;
//        getContentPane().setSize(120,120);
//        this.setSize(100,100);
//        JLabel jLabel1 = new javax.swing.JLabel();
//        jLabel1.setBounds(25, 100, 100, 20);
//        jLabel1.setText("PaklSound 1.00");
//        jLabel1.setVisible(true);
//        getContentPane().add(jLabel1);
//        this.setVisible(true);
//        getContentPane().update(getContentPane().getGraphics());
//        addWindowListener(new java.awt.event.WindowAdapter()
//        {
//            public void windowClosing(java.awt.event.WindowEvent evt)
//            {
//                localPaklSound.setStopRequested();
//                // System.exit(0);
//            }
//        });
        
    }


//    public void openBiggest()
//    {
//            // Obtain information about all the installed synthesizers.
//            Vector synthInfos = new Vector();
//            MidiDevice device = null;
//            MidiDevice.Info[] infos = MidiSystem.getMidiDeviceInfo();
//            for (int i = 0; i < infos.length; i++) {
//                try {
//                    device = MidiSystem.getMidiDevice(infos[i]);
//                } catch (MidiUnavailableException e) {
//                      // Handle or throw exception...
//                }
//                if (device instanceof Synthesizer) {
//                    synthInfos.add(infos[i]);
//                }
//            }
//            System.out.println(synthInfos);
//    }
    
    public void openMidi() 
    {
        try 
        {
            if (synthesizer == null) 
            {
                if ((synthesizer = MidiSystem.getSynthesizer()) == null) 
                {
                    System.out.println("getSynthesizer() failed!");
                    return;
                }
            } 
            synthesizer.open();
            sequencer = MidiSystem.getSequencer();
            sequence = new Sequence(Sequence.PPQ, 10);
        } catch (Exception ex) { ex.printStackTrace(); return; }

        Soundbank sb = synthesizer.getDefaultSoundbank();
	if (sb != null) 
        {
            instruments = synthesizer.getDefaultSoundbank().getInstruments();
            synthesizer.loadInstrument(instruments[0]);
        }
        MidiChannel midiChannels[] = synthesizer.getChannels();
        channels = new ChannelData[midiChannels.length];
        for (int i = 0; i < channels.length; i++) 
        {
            channels[i] = new ChannelData(midiChannels[i], i);
        }
        cc = channels[0];
    }

    public void closeMidi() {
        if (synthesizer != null) 
        {
            synthesizer.close();
        }
        if (sequencer != null) 
        {
            sequencer.close();
        }
        sequencer = null;
        synthesizer = null;
        instruments = null;
        channels = null;
        System.out.println("close finished");
    }





    class ChannelData 
    {
        MidiChannel channel;
        boolean solo, mono, mute, sustain;
        int velocity, pressure, bend, reverb;
        int row, col, num;
 
        public ChannelData(MidiChannel channel, int num) 
        {
            this.channel = channel;
            this.num = num;
            velocity = pressure = bend = reverb = 64;
        }
    } 


    public int [] scaleFor(int note)
    {
        int [] result = {note, note+2, note+4, note+5, note+7, note+9, note+11, note+12}; 
        return result;
    }

    
    int [] chordSequence = {60, 60+4, 60+5, 60+7};
    int [] transitionNotes = {60, 60+4, 60+5, 60+7};
    int [] chordNoteSrcs = {60, 60, 60, 60};
    long [] noteTimes = {250, 500};
    int numNotesPerMeasure = 12;
    private boolean stopRequested;
    int numMeasures = 4;
    
    public void setNoteTimes(String s)
    {
        StringTokenizer t = new StringTokenizer(s, " ", false);
        noteTimes = new long[t.countTokens()];
        int i = 0;
        while (t.hasMoreTokens())
        {
            noteTimes[i] = new Long(t.nextToken()).longValue();
            i++;
        }
    }

    public void setChordSequence(String s)
    {
        StringTokenizer t = new StringTokenizer(s, " ", false);
        chordSequence = new int[t.countTokens()];
        int i = 0;
        while (t.hasMoreTokens())
        {
            chordSequence[i] = new Integer(t.nextToken()).intValue();
            i++;
        }
    }
    public void setChordNoteSrcs(String s)
    {
        StringTokenizer t = new StringTokenizer(s, " ", false);
        chordNoteSrcs = new int[t.countTokens()];
        int i = 0;
        while (t.hasMoreTokens())
        {
            chordNoteSrcs[i] = new Integer(t.nextToken()).intValue();
            i++;
        }
    }
    public void setTransitionNotes(String s)
    {
        StringTokenizer t = new StringTokenizer(s, " ", false);
        transitionNotes = new int[t.countTokens()];
        int i = 0;
        while (t.hasMoreTokens())
        {
            transitionNotes[i] = new Integer(t.nextToken()).intValue();
            i++;
        }
    }    

    public void setNumMeasures(int numMeasures)
    {
        this.numMeasures = numMeasures;
    }
    
    public void setNumNotesPerMeasure(int n)
    {
        this.numNotesPerMeasure = n;
    }
    
    public void setStopRequested()
    {
        stopRequested = true;
    }

    private boolean isRunning = false;
    public boolean isRunning()
    {
        return isRunning;
    }
    
    public void init()
    {
        openMidi();
        synthesizer.loadInstrument(instruments[0]);
        cc.channel.programChange(0);
    }
    public void shutdown()
    {
        closeMidi();
    }
    
    public void run()
    {
        isRunning = true;
        init();
        waves1();
        shutdown();
        //this.setVisible(false);
        isRunning = false;
    }

    public void setInstrument(int number)
    {
        synthesizer.loadInstrument(instruments[number]);
        cc.channel.programChange(number);
    }
    
    public void playTone(int note, long duration)
    {
        cc.channel.noteOn(note, cc.velocity);
        //try { Thread.sleep(10); } catch (Exception e) {}
        //cc.channel.noteOff(note, cc.velocity);                    
    }
    public void allNotesOff()
    {
        cc.channel.allNotesOff();
    }

    public void waves1()
    {
        
        for (int m = 0; m < numMeasures; m++)
        {
            if (stopRequested == true) {stopRequested = false; break;}
            for (int i = 0; i < chordSequence.length; i++)
            {
                Thread.yield();
                // int note = randomNote(30, 60);
                int baseNote = chordSequence[i];
                int sourceNote = chordNoteSrcs[i];
                cc.channel.noteOn(baseNote-12, cc.velocity);

                int subtractOne = 0;
                if (i < this.transitionNotes.length) { subtractOne = 1; } 
                for (int j = 0; j < (numNotesPerMeasure-subtractOne); j++)
                {
                    int randomNoteInChord = (int) (Math.random() * (double) scaleFor(sourceNote).length); 
                    cc.channel.noteOn(scaleFor(sourceNote)[randomNoteInChord], cc.velocity);
                    try { Thread.sleep(randomTime(noteTimes)); } catch (Exception e) {}
                    cc.channel.noteOff(scaleFor(sourceNote)[randomNoteInChord], cc.velocity);                    
                }
                if (i < this.transitionNotes.length)
                {
                    System.out.println("Use transition note!");
                    cc.channel.noteOn(transitionNotes[i], cc.velocity);
                    try { Thread.sleep(randomTime(noteTimes)); } catch (Exception e) {}
                    cc.channel.noteOff(transitionNotes[i], cc.velocity);    
                }
                
                cc.channel.noteOff(baseNote-12, cc.velocity);
            }
        }
    }
    
    
    public int randomNote(int lowest, int highest)
    {
        return lowest + (int) (Math.random() * (int) (highest - lowest));
    }
    
    public long randomTime(long[] times)
    {
        return times[(int) (Math.random() * (double) times.length)];
    }
    
    public long randomTime(long shortest, long longest)
    {
        return shortest + (long) (Math.random() * (double) (longest - shortest)); 
    }
    
    public static void main(String args[]) 
    {
        final PaklSound paklSound = new PaklSound();

        paklSound.setChordSequence("60 64 65 67");
        paklSound.setChordNoteSrcs("60 60 60 60");
        paklSound.setNoteTimes("250 500");
        paklSound.setNumNotesPerMeasure(6);
        paklSound.openMidi();
        paklSound.waves1();
        paklSound.closeMidi();
        System.exit(0);
    }
    
    
} 
