import java.io.*;
import java.util.*;
import java.net.*;

import javax.swing.*;
import java.awt.*;

import javax.sound.sampled.*;


public class WiiSound2
{

    public final boolean ENABLE_FULL_SCREEN_MODE = true;		// turn off if you want to debug/stdout

    PaklSound p;
boolean nunchukConnected = false;
boolean wiimoteConnected = false;
JLabel wiimoteStatus;
JLabel nunchukStatus;
    
    public static void main(String args[])
    {
        WiiSound2 me = new WiiSound2();
        me.run();
    }

    public WiiSound2()
    {
	GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
	GraphicsDevice[] gs = ge.getScreenDevices();	
	GraphicsConfiguration[] gc = gs[0].getConfigurations();

	JWindow frame = new JWindow();
	frame.setLayout(new GridLayout(2,1));
	frame.getContentPane().setBackground(Color.BLACK);
	JPanel panel = new JPanel();
	JPanel panel2 = new JPanel();
	panel2.setLayout(new BoxLayout(panel2, BoxLayout.PAGE_AXIS));
	panel.setBounds(0,0, (int)gc[0].getBounds().getWidth(), (int)gc[0].getBounds().getHeight()/2);	
	panel.setBounds(0,(int)gc[0].getBounds().getHeight()/2, (int)gc[0].getBounds().getWidth(), (int)gc[0].getBounds().getHeight()/2);	
	panel.setBackground(Color.BLACK);
	panel2.setBackground(Color.BLACK);
	frame.add(panel);
	frame.add(panel2);

	JLabel myImage = new JLabel();
	JLabel dummyLabel = new JLabel("");
        myImage.setIcon(new javax.swing.ImageIcon("splashscreen.png"));
	myImage.setBounds(gc[0].getBounds());	
	System.out.println(gc[0].getBounds());

	wiimoteStatus = new JLabel();
	nunchukStatus = new JLabel();
	wiimoteStatus.setBackground(Color.BLACK);
	wiimoteStatus.setForeground(Color.RED);
	nunchukStatus.setBackground(Color.BLACK);
	nunchukStatus.setForeground(Color.RED);
	wiimoteStatus.setText("Wiimote: Not Connected");
	nunchukStatus.setText("Nunchuk: Not Connected");

	panel.add(myImage);
	myImage.setVisible(true);

	JTextArea instructions = new JTextArea();
	instructions.setBackground(Color.BLACK);
	instructions.setForeground(Color.WHITE);
	instructions.setText("Wii Strum Interface Version 1-prerelease1\n\n"+
			 "Created by:\nPatryk Laurent (patryk@pakl.net) \n"
			+"\n"
			+"\n"
			+ "To connect, press 1 and 2 on your Wiimote.\n"
			+ "Hold down A to strum!!\n"
			+ "To quit, press the Home Button on your Wiimote.\n"
			+"\n"
			+"\n"
			+"	(For updates go to http://pakl.net/wii)\n"
			);
	panel.add(instructions);

	JButton quitButton = new JButton("force quit");
	quitButton.setBackground(Color.BLACK);
	panel2.add(wiimoteStatus);
	panel2.add(nunchukStatus);
	panel2.add(quitButton);	
	panel2.add(dummyLabel);
	frame.pack();
	//quitButton.setBounds(0,60, (int)quitButton.getBounds().getWidth(), (int)quitButton.getBounds().getHeight());
	//wiimoteStatus.setBounds(0,0, (int)wiimoteStatus.getBounds().getWidth(), (int)wiimoteStatus.getBounds().getHeight());
	//nunchukStatus.setBounds(0,30, (int)nunchukStatus.getBounds().getWidth(), (int)nunchukStatus.getBounds().getHeight());
	quitButton.addActionListener(new java.awt.event.ActionListener()
	{
		public void actionPerformed(java.awt.event.ActionEvent evt)
		{
			System.exit(0);
		}
	});
	if (ENABLE_FULL_SCREEN_MODE)
	{
		gs[0].setFullScreenWindow(frame);	
	}
    }
    
    public void instructions()
    {
        System.out.println("WiiStrum Version 1A");
        System.out.println("-------------------");
	System.out.println("Developed by Patryk Laurent");
    }
    
    public void run()
    {
        HashMap <String,Double> wiimote = new HashMap<String,Double>();
        HashMap <String,Double> previous = null;
        
        int refractory2 = 0;
        int xPosition = 0;
        int samples = 0;
        
        try
        {
            initializeSound();
            instructions();
            Scanner scanner = new Scanner(System.in);
            while (scanner.hasNextLine())
            {
                String s = scanner.nextLine();
                try
                {
		    if (s.equals("signal_quit")) 
			{
				System.out.println("Received quit signal.");
				System.exit(0);
			}
                    wiimote = hash(s);
	 		if (samples % 100 == 0)
			{
		
		    if (!wiimoteConnected && wiimote.get("wfx") > 0) { wiimoteConnected = true; wiimoteStatus.setText("Wiimote: Connected"); wiimoteStatus.setForeground(Color.GREEN); }
                    if (!nunchukConnected && (wiimote.get("nfx") > 0)) { nunchukConnected = true; nunchukStatus.setText("Nunchuk: Connected"); nunchukStatus.setForeground(Color.GREEN); }
		    if (nunchukConnected && (wiimote.get("nfx") == 255)) { System.out.println("DISCONNECTED!"); nunchukConnected = false; nunchukStatus.setText("Nunchuk: Not Connected"); nunchukStatus.setForeground(Color.RED); }
			}
                    if (previous==null) previous=wiimote;
                    playAppropriateNote(wiimote,previous);
                    if (refractory2 == 0 && wiimote.get("w^")==1)
                    {
                        instrumentNumber++; p.setInstrument(instrumentNumber);
                        System.out.println("Changed to MIDI instrument number: "+instrumentNumber);
                        refractory2 = 25;
                    }
                    if (refractory2 == 0 && wiimote.get("wv")==1)
                    {
                        instrumentNumber--; p.setInstrument(instrumentNumber);
                        System.out.println("Changed to MIDI instrument number: "+instrumentNumber);
                        refractory2 = 25;
                    }
                    samples++;
                    if (refractory2 >0) refractory2--;

                    previous = wiimote;
                }
                catch (NoSuchElementException nsee)
                {
                    System.out.println("- Line was missing data or incomplete.");
                }
                catch (NullPointerException npe)
                {
                    System.out.println("- Line was probably missing a field.");
                }
            }
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }
    int refractoryA = 0;
    int refractoryB = 0;
    int refractoryC = 0;
    int refractoryD = 0;
    
    int refractoryDOWN = 0;
    int refractoryUP = 0;
    
    double NOTE_SIZE = 5;
    double GAP_SIZE = 2;
    double gap0start =  115;      double gap0cease =  gap0start + GAP_SIZE;
    double note1start = gap0cease;  double note1cease = note1start + NOTE_SIZE;
    double gap1start =  note1cease; double gap1cease =  gap1start + GAP_SIZE;
    double note2start = gap1cease;  double note2cease = note2start + NOTE_SIZE;
    double gap2start =  note2cease; double gap2cease =  gap2start + GAP_SIZE;
    double note3start = gap2cease;  double note3cease = note3start + NOTE_SIZE;
    double gap3start =  note3cease; double gap3cease =  gap3start + GAP_SIZE;
    double note4start = gap3cease;  double note4cease = note4start + NOTE_SIZE;
    double gap4start =  note4cease; double gap4cease =  gap4start + GAP_SIZE;
    int FASTER_DECAY = 1;
    final int REFRACTORY_DEFAULT = 80;

    int chord = 0;

    public void downstrum(HashMap<String,Double> wiimote)
    {
        //System.out.println("downstrum");
        p.playTone(notes[chord][0], 50);
        try { Thread.sleep(15); } catch (Exception e) {}

        if (wiimote.get("nz")==1)
            p.playTone(notes[chord][3]-2, 50);
        else
            p.playTone(notes[chord][3], 50);
        try { Thread.sleep(15); } catch (Exception e) {}

        p.playTone(notes[chord][2], 50);
        try { Thread.sleep(15); } catch (Exception e) {}

        if (wiimote.get("nc")==1)
            p.playTone(notes[chord][1]-1, 50);
        else
            p.playTone(notes[chord][1], 50);

        
    }
    public void upstrum(HashMap<String,Double> wiimote)
    {
        //System.out.println("upstrum");
        p.playTone(notes[chord][0], 50);
        try { Thread.sleep(15); } catch (Exception e) {}
        if (wiimote.get("nc")==1)
            p.playTone(notes[chord][1]-1, 50);
        else
            p.playTone(notes[chord][1], 50);
        try { Thread.sleep(15); } catch (Exception e) {}
        p.playTone(notes[chord][2], 50);
        try { Thread.sleep(15); } catch (Exception e) {}
        if (wiimote.get("nz")==1)
            p.playTone(notes[chord][3]-2, 50);
        else
            p.playTone(notes[chord][3], 50);
    }
    
    public void playAppropriateNote(HashMap<String,Double> wiimote,HashMap<String,Double> previous)
    {
        
            if (wiimote.get("joyy") > 180) chord = 0;   
            else
            if (wiimote.get("joyx") > 180) chord = 1;
            else
            if (wiimote.get("joyy") < 50) chord = 2;
            else
            if (wiimote.get("joyx") < 50) chord = 3;
            else
            chord = 4;
        if (wiimote.get("wa") == 0)
        {
            if (previous.get("wa") == 1) 
            {
                p.allNotesOff();
            }
            refractoryA=0;
            refractoryB=0;
            refractoryC=0;
            refractoryD=0;
        }
        if (wiimote.get("wa") == 1)
        {
		if ((wiimote.get("wb") == 1) && (previous.get("wb") == 0))
		{
					upstrum(wiimote); 
		}
		if ((previous.get("wb") == 1) && (wiimote.get("wb") == 0))
		{
					downstrum(wiimote); 
		} 
            double strum = wiimote.get("wfy");

            if (strum < gap0cease)
            {
                refractoryA -= FASTER_DECAY;
            }
            if (strum > gap4start)
            {
                refractoryD -= FASTER_DECAY;
                refractoryC = 0;
            }
            if (strum > note1start && strum < note1cease)
            {
                if (refractoryA <= 0)
                {
                    p.playTone(notes[chord][0], 50);
                    refractoryA = REFRACTORY_DEFAULT;
                    refractoryB = 0;
                    refractoryC = 0;
                    refractoryD = 0;
                }
                //return;
            }
            if (strum > note4start && strum < note4cease)
            {
                if (refractoryD <= 0)
                {
                    if (wiimote.get("nz")==1)
                    {
                        p.playTone(notes[chord][3]-2, 50);   // 7th
                    }
                    else
                    {
                        p.playTone(notes[chord][3], 50);
                    }
                    refractoryD = REFRACTORY_DEFAULT; 
                    refractoryB  = 0;
                    refractoryC  = 0;
                    refractoryA  = 0;
                }
                //return;
            }
            if (strum > gap1start && strum < gap1cease)
            {
                refractoryA  -= FASTER_DECAY;
                refractoryB  -= FASTER_DECAY;
            }
            if (strum > note2start && strum < note2cease)
            {
                if (refractoryB <= 0)
                {
                    if (wiimote.get("nc")==1)
                    {
                        p.playTone(notes[chord][1]-1, 50);
                    }
                    else
                    {
                        p.playTone(notes[chord][1], 50);
                    }
                    refractoryB = REFRACTORY_DEFAULT;
                    refractoryA  = 0;
                    refractoryC  = 0;
                    refractoryD  = 0;
                }
                //return;
            }
            if (strum > gap2start && strum < gap2cease)
            {
                refractoryB  -= FASTER_DECAY;
                refractoryC  -= FASTER_DECAY;
            }
            if (strum > note3start && strum < note3cease)
            {
                if (refractoryC <= 0)
                {
                    p.playTone(notes[chord][2], 50);
                    refractoryC = REFRACTORY_DEFAULT;
                    refractoryB  = 0;
                    refractoryA  = 0;
                    refractoryD  = 0;
                }
                //return;
            }
            if (strum > gap3start && strum < gap3cease)
            {
                refractoryC  -= FASTER_DECAY;
                refractoryD  -= FASTER_DECAY;
            }
        }
        if (refractoryA > 0) refractoryA--;
        if (refractoryB > 0) refractoryB--;
        if (refractoryC > 0) refractoryC--;
        if (refractoryD > 0) refractoryD--;
    }
    
    public HashMap hash(String data)
    {
        HashMap <String,Double> result = new HashMap<String,Double>();
        StringTokenizer t = new StringTokenizer(data, " ");
        while (t.hasMoreTokens())
        {
            StringTokenizer u = new StringTokenizer(t.nextToken(), "=");
            String key = u.nextToken();
            String value = u.nextToken();
            if (value.equals("nan")) value = "0";
            Double valueNumber = new Double(value);
            result.put(key,valueNumber);
        }
        return result;
    }
    int instrumentNumber = 24;
    
    public void initializeSound()
    {
        p = new PaklSound();
        p.openMidi();
        p.setInstrument(instrumentNumber);
        
        notes[0][0] = 60; notes[0][1] = notes[0][0]+4; notes[0][2] = notes[0][0]+7; notes[0][3] = notes[0][0]+12;
        notes[1][0] = 64; notes[1][1] = notes[1][0]+4; notes[1][2] = notes[1][0]+7; notes[1][3] = notes[1][0]+12;
        notes[2][0] = 65; notes[2][1] = notes[2][0]+4; notes[2][2] = notes[2][0]+7; notes[2][3] = notes[2][0]+12;
        notes[3][0] = 67; notes[3][1] = notes[3][0]+4; notes[3][2] = notes[3][0]+7; notes[3][3] = notes[3][0]+12;
        notes[4][0] = 69; notes[4][1] = notes[4][0]+4; notes[4][2] = notes[4][0]+7; notes[4][3] = notes[4][0]+12;
    }
    
    int [][] notes = new int[5][4];
}

